/*
 * Written by Professor Bill Tomlinson for Winter 2004 Biomorphic Computing class at UCI.
 * wmt@uci.edu
 */
public class Creature {
	private Vec2 pos =
		new Vec2(
			Math.random() * Flock.xSize * Flock.cellSize * .9 + 20,
			Math.random() * Flock.ySize * Flock.cellSize * .9 + 20);
	private Vec2 forward = new Vec2(0, 1);
	private int id = 0;
	private static int idCounter = 1;

	public Creature() {
		id = idCounter;
		idCounter++;
		pos.setValue(
			Math.random() * Flock.xSize * Flock.cellSize,
			Math.random() * Flock.ySize * Flock.cellSize);
	}
	public void update() {
		//		System.out.println("Updating creature");
		//TO DO 
		//MAKE FLOCKING HAPPEN HERE
		//don't forget that this world is toroidal, 
		//so you will need to account for the edges in the creatures' sensation.

		//these lines provide a random walk.  You should probably remove them.
		pos.setValue(
			pos.x + (Math.random() - 0.5) * 10,
			pos.y + (Math.random() - 0.5) * 10);
		if (pos.x > Flock.xSize * Flock.cellSize)
			pos.setX(pos.x - Flock.xSize * Flock.cellSize);
		if (pos.x < 0)
			pos.setX(pos.x + Flock.xSize * Flock.cellSize);
		if (pos.y > Flock.ySize * Flock.cellSize)
			pos.setY(pos.y - Flock.ySize * Flock.cellSize);
		if (pos.y < 0)
			pos.setY(pos.y + Flock.ySize * Flock.cellSize);
		forward.setValue(Math.random() - 0.5, Math.random() - 0.5);
		forward = forward.normalize();
	}
	public Vec2 getPosition() {
		return pos;
	}
	public Vec2 getForwardVec() {
		return forward;
	}
	public int getID() {
		return id;
	}
}