/*
 * Written by Professor Bill Tomlinson for Winter 2004 Biomorphic Computing class at UCI.
 * wmt@uci.edu
 */
import java.applet.Applet;
import java.awt.*;
import java.util.Vector;

public class Flock extends Applet {
	//Milliseconds to sleep
	public final int SLEEP_TIME = 100;
	//how many blocks in x
	public static int xSize = 100;
	//how many blocks in y
	public static int ySize = 100;
	//how many pixels per block
	public static int cellSize = 5;
	//in this version of the grid world:
	//0 through FLOCK_SIZE is the number in each of these squares
	public static Vector[][] blocks = new Vector[xSize][ySize];
	Color backgroundColor = Color.gray;
	static Canvas gridCanvas;
	private static Vector allCreatures = new Vector();
	int NUMBER_OF_CREATURES = 10;

	public void init() {
		for (int thisX = 0; thisX < xSize; thisX++) {
			for (int thisY = 0; thisY < ySize; thisY++) {
				blocks[thisX][thisY] = new Vector();
			}
		}
		for (int i = 1; i <= NUMBER_OF_CREATURES; i++) {
			Creature c = new Creature();
			allCreatures.add(c);
			blocks[(int) (c.getPosition().x / (double) cellSize)][(int)
				(c.getPosition().y / (double) cellSize)].add(
				c);
		}

		setLayout(new BorderLayout());
		gridCanvas = new Canvas() {
			public void paint(Graphics g) {
				setBackground(backgroundColor);
				g.clearRect(
					1,
					1,
					(xSize * cellSize) - 2,
					(ySize * cellSize) - 2);

				for (int thisX = 0; thisX < xSize; thisX++) {
					for (int thisY = 0; thisY < ySize; thisY++) {

						if (blocks[thisX][thisY].size() < 1) {
							//System.out.println("Printing the target: "+thisX+", "+thisY);
							g.setColor(Color.white);
							g.fillRect(
								thisX * cellSize,
								thisY * cellSize,
								cellSize - 1,
								cellSize - 1);
						} else {
							Creature c =
								((Creature) (blocks[thisX][thisY]
									.elementAt(0)));
							g.setColor(Color.black);
							g.fillRect(
								thisX * cellSize,
								thisY * cellSize,
								cellSize - 1,
								cellSize - 1);
							g.setColor(Color.white);
							g.drawLine(
								thisX * cellSize + cellSize / 2 - 1,
								thisY * cellSize + cellSize / 2 - 1,
								(int) (thisX * cellSize
									+ cellSize / 2
									- 1
									+ c.getForwardVec().getX() * (cellSize - 1)),
								(int) (thisY * cellSize
									+ cellSize / 2
									- 1
									+ c.getForwardVec().getY() * (cellSize - 1)));
						}
					}
				}
			}
		};
		Panel controlPanel = new Panel();
		controlPanel.setSize(30, 10);
		gridCanvas.setSize(500, 500);
		setLayout(new BorderLayout());
		add(BorderLayout.CENTER, gridCanvas);
		add(BorderLayout.SOUTH, controlPanel);
		setVisible(true);
		validate();
		while (true) {
			//do something
			for (int i = 0; i < allCreatures.size(); i++) {
				Creature c = ((Creature) allCreatures.elementAt(i));
				Vec2 oldPos = c.getPosition();
				blocks[(int) (oldPos.x / (double) cellSize)][(int)
					(oldPos.y / (double) cellSize)].remove(
					c);
				c.update();
				blocks[(int) (c.getPosition().x / (double) cellSize)][(int)
					(c.getPosition().y / (double) cellSize)].add(
					c);
			}
			try {
				Thread.sleep(SLEEP_TIME);
			} catch (Exception e) {
			}
			gridCanvas.repaint();
		}
	}
	public Vector getAllCreatures() {
		return allCreatures;
	}
}
